#ifndef __bbmaracasvisuAnimationSphere_h_INCLUDED__
#define __bbmaracasvisuAnimationSphere_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"


#include <vtkRenderer.h>
#include <vtkActor.h>
#include <vtkSphereSource.h>
#include <vtkLinearTransform.h>


namespace bbcreaMaracasVisu
{

class /*BBTK_EXPORT*/ AnimationSphere
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(AnimationSphere,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(Renderer ,vtkRenderer*);
  BBTK_DECLARE_INPUT(Index,int);
  BBTK_DECLARE_INPUT(Step,int);
  BBTK_DECLARE_INPUT(lstIndexs,std::vector<int>);
  BBTK_DECLARE_INPUT(lstPointX,std::vector<double>);
  BBTK_DECLARE_INPUT(lstPointY,std::vector<double>);
  BBTK_DECLARE_INPUT(lstPointZ,std::vector<double>);
  BBTK_DECLARE_INPUT(lstRadio ,std::vector<double>);
  BBTK_DECLARE_INPUT(Colour   ,std::vector<double>);
  BBTK_DECLARE_INPUT(Opacity  ,double);
  BBTK_DECLARE_INPUT(Transform, vtkLinearTransform *);
//  BBTK_DECLARE_OUTPUT(Out,double);
  BBTK_PROCESS(Process);
  void Process();

  vtkActor			*sphereActor;
  vtkSphereSource	*vtksphere;

};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(AnimationSphere,bbtk::AtomicBlackBox);
BBTK_NAME("AnimationSphere");
BBTK_AUTHOR("InfoTeam  CREATIS-LRMN");
BBTK_DESCRIPTION("Animation Sphere");
BBTK_CATEGORY("Animation");
BBTK_INPUT(AnimationSphere,Renderer,"Renderer",vtkRenderer*,"");
BBTK_INPUT(AnimationSphere,Index,"Indexs",int,"");
BBTK_INPUT(AnimationSphere,Step,"Step",int,"");
BBTK_INPUT(AnimationSphere,lstIndexs,"list of Indexs",std::vector<int>,"");
BBTK_INPUT(AnimationSphere,lstPointX,"lstPointX",std::vector<double>,"");
BBTK_INPUT(AnimationSphere,lstPointY,"lstPointY",std::vector<double>,"");
BBTK_INPUT(AnimationSphere,lstPointZ,"lstPointZ",std::vector<double>,"");
BBTK_INPUT(AnimationSphere,lstRadio,"lstRadio",std::vector<double>,"");
BBTK_INPUT(AnimationSphere,Colour,"Colour",std::vector<double>,"");
BBTK_INPUT(AnimationSphere,Opacity,"Opacity of the sphere",double,"");
BBTK_INPUT(AnimationSphere,Transform,"vtkTransform", vtkLinearTransform *,"");
//BBTK_OUTPUT(AnimationSphere,Out,"First output",double,"");
BBTK_END_DESCRIBE_BLACK_BOX(AnimationSphere);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbmaracasvisuAnimationSphere_h_INCLUDED__

