#include "bbmaracasvisuAxeVolume.h"
#include "bbcreaMaracasVisuPackage.h"
namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,AxeVolume)
BBTK_BLACK_BOX_IMPLEMENTATION(AxeVolume,bbtk::AtomicBlackBox);
void AxeVolume::Process()
{
	if ( mimage!=NULL )
	{
		mimage->Delete();
	}

	int ext[6];
	bbGetInputIn()->GetExtent(ext);
	int sizeX=ext[1]-ext[0];
	int sizeY=ext[3]-ext[2];
	int sizeZ=ext[5]-ext[4];

	mimage = vtkImageData::New(); 
	mimage->SetDimensions(sizeX,sizeY,sizeZ);
	mimage->SetOrigin(0,0,0);
	mimage->SetExtent( 0 , sizeX-1 , 0 , sizeY-1 , 0, sizeZ-1 );
	mimage->SetWholeExtent( 0 , sizeX-1 , 0 , sizeY-1 , 0, sizeZ-1 );
	mimage->SetScalarTypeToUnsignedShort();
	mimage->AllocateScalars();


	int i,j,k;
    int sizeLstPointR = bbGetInputlstPointR().size();
	int iAxe,sizeAxe=bbGetInputlstPointX().size();
	double rx,ry,rz;
	double r,rr;
	unsigned short *p;
	int sizeImage = sizeX*sizeY*sizeZ;
	double px,py,pz,px1,py1,pz1,px2,py2,pz2;

	// Clean image
	p = (unsigned short*)mimage->GetScalarPointer (0, 0, 0);
	for ( i=0 ; i<sizeImage ; i++)
	{
		*p = 0;
		p++;
	}

	for (iAxe=0 ; iAxe<sizeAxe; iAxe++)
	 {
		if (sizeLstPointR<iAxe)
		{
			r = bbGetInputlstPointR()[ bbGetInputlstPointR().size() ];
		} else {
			r = bbGetInputlstPointR()[ iAxe ];
		}
		px = bbGetInputlstPointX()[iAxe];
		py = bbGetInputlstPointY()[iAxe];
		pz = bbGetInputlstPointZ()[iAxe];
		px1 = px - r;
		py1 = py - r;
		pz1 = pz - r;
		px2 = px + r;
		py2 = py + r;
		pz2 = pz + r;

		for ( i=px1 ; i<=px2 ; i++ ) 
		{
			for ( j=py1 ; j<py2 ; j++ ) 
			{
				for ( k=pz1 ; k<pz2 ; k++ ) 
				{
					if ( (i>=0) && (i<sizeX) && (j>=0) && (j<sizeY) &&(k>=0) && (k<sizeZ) ){
						rx	= i - px;
						ry	= j - py;
						rz	= k - pz;
						rr	= rx*rx + ry*ry + rz*rz;
						if ( rx*rx + ry*ry + rz*rz <= r*r )
						{
							p = (unsigned short*)mimage->GetScalarPointer (i, j, k);
							*p=255;
						} 
					} // inside point
				} //for k
			} //for j
		} //for i
	} // for iAxe
    bbSetOutputOut( mimage ); 
}


	//-----------------------------------------------------------------	
	void AxeVolume::bbUserSetDefaultValues()
	{
		mimage=NULL;
	}
	
	//-----------------------------------------------------------------	
	void AxeVolume::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void AxeVolume::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	
}
// EO namespace bbcreaMaracasVisu


