#include "bbmaracasvisuContourCrown.h"
#include "bbcreaMaracasVisuPackage.h"

#include <vtkImageData.h>

namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ContourCrown)
BBTK_BLACK_BOX_IMPLEMENTATION(ContourCrown,bbtk::WxBlackBox);

//-----------------------------------------------------------
void ContourCrown::Process()
{

	if (mwxwidget!=NULL){
		//JSTG 04-04-08
		mwxwidget->SetControlPoints( bbGetInputControlPointsInX(), bbGetInputControlPointsInY(), bbGetInputControlPointsInZ() );
		
		LstValuePosX.clear();
		LstValuePosY.clear();
		LstValuePosZ.clear();
		mwxwidget->GetValuesInsideCrown(&LstValue,&LstValuePosX,&LstValuePosY,&LstValuePosZ);

		//JSTG 226-02-08 ----------------------------------------------------------
		LstContourX.clear();
		LstContourY.clear();
		LstContourZ.clear();
		mwxwidget->GetSplinePoints(&LstContourX,&LstContourY,&LstContourZ);
		//-------------------------------------------------------------------------

		bbSetOutputLstValue(&LstValue);
		bbSetOutputLstValuePosX(&LstValuePosX);
		bbSetOutputLstValuePosY(&LstValuePosY);
		bbSetOutputLstValuePosZ(&LstValuePosZ);
		bbSetOutputLstContourX(&LstContourX);
		bbSetOutputLstContourY(&LstContourY);
		bbSetOutputLstContourZ(&LstContourZ);
		bbSetOutputLstContourCrlX(&LstContourCrlX);
		bbSetOutputLstContourCrlY(&LstContourCrlY);
		bbSetOutputLstContourCrlZ(&LstContourCrlZ);
		bbSetOutputLstContourCrlZ(&LstContourCrlZ);
	} // mwxwidget
}

//-----------------------------------------------------------
void ContourCrown::CreateWidget(wxWindow* parent)
{
	bbtkDebugMessageInc("Core",9,"ContourCrown::CreateWidget()"<<std::endl);
  
	if (bbGetInputwxVtkBaseView()==NULL) 
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ContourCrown) Input 'wxVtkBaseView' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }
	if (bbGetInputIn()==NULL) 
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ContourCrown) Input 'In' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }

	mwxwidget = new wxMaracasCoutourTool( parent, bbGetInputwxVtkBaseView(), bbGetInputIn() );
	mwxwidget->ConfigureVTK();

	bbSetOutputImageValueResult( mwxwidget->GetVtkImageValueResult() );
	bbSetOutputImageMaskResult( mwxwidget->GetVtkImageMaskResult() );
	bbSetOutputWidget(mwxwidget);
	bbtkDebugDecTab("Core",9);
}

//-----------------------------------------------------------
void ContourCrown::bbUserSetDefaultValues()
{
	mwxwidget = NULL;
	bbSetInputIn(NULL);
	bbSetInputwxVtkBaseView(NULL);
//JSTG 26-02-08 ------------------------------------
	bbSetInputControlPointsInX(NULL);
	bbSetInputControlPointsInY(NULL);
	bbSetInputControlPointsInZ(NULL);
//--------------------------------------------------
}

	//-----------------------------------------------------------------	
	void ContourCrown::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void ContourCrown::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	

}
// EO namespace bbcreaMaracasVisu


