#ifndef __bbcreaMaracasVisuContourStatistics_h_INCLUDED__
#define __bbcreaMaracasVisuContourStatistics_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"

namespace bbcreaMaracasVisu
{

class /*BBTK_EXPORT*/ ContourStatistics
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ContourStatistics,bbtk::AtomicBlackBox);
	BBTK_DECLARE_INPUT(LstValue,std::vector<double>*);
	BBTK_DECLARE_INPUT(LstValuePosX,std::vector<double>*);
	BBTK_DECLARE_INPUT(LstValuePosY,std::vector<double>*);
	BBTK_DECLARE_INPUT(LstValuePosZ,std::vector<double>*);
    BBTK_DECLARE_OUTPUT(Max,double);
    BBTK_DECLARE_OUTPUT(Min,double);
    BBTK_DECLARE_OUTPUT(Average,double);
    BBTK_DECLARE_OUTPUT(StandarDeviation,double);
	BBTK_DECLARE_OUTPUT(nPoints,int);
  BBTK_PROCESS(Process);
  void Process();
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ContourStatistics,bbtk::AtomicBlackBox);
BBTK_NAME("ContourStatistics");
BBTK_AUTHOR("eduardo.davila [at] creatis.insa-lyon.fr");
BBTK_DESCRIPTION("Basic contour statistics");
BBTK_CATEGORY("math");
    BBTK_INPUT(ContourStatistics,LstValue,"Pixel values",std::vector<double>*,"");
    BBTK_INPUT(ContourStatistics,LstValuePosX,"Pixel position X",std::vector<double>*,"");
    BBTK_INPUT(ContourStatistics,LstValuePosY,"Pixel position Y",std::vector<double>*,"");
    BBTK_INPUT(ContourStatistics,LstValuePosZ,"Pixel position Z",std::vector<double>*,"");
    BBTK_OUTPUT(ContourStatistics,Max,"Max",double,"");
    BBTK_OUTPUT(ContourStatistics,Min,"Min",double,"");
    BBTK_OUTPUT(ContourStatistics,Average,"Average",double,"");
    BBTK_OUTPUT(ContourStatistics,StandarDeviation,"Standar Deviation",double,"");
    BBTK_OUTPUT(ContourStatistics,nPoints,"Number of values",int,"");
BBTK_END_DESCRIBE_BLACK_BOX(ContourStatistics);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuContourStatistics_h_INCLUDED__

