

#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuContourVOI_h_INCLUDED__
#define __bbcreaMaracasVisuContourVOI_h_INCLUDED__
#include "bbtkWxBlackBox.h"


#include <vtkImageData.h>
#include <vtkExtractVOI.h>

#include "Contour/ContourVOIWidget.h"

namespace bbcreaMaracasVisu
{


  //--------------------------------------------------------------------------
  class ContourVOI;
  class wxWidgetVOI : public wxPanel
  {
	public:
		wxWidgetVOI(wxWindow* parent, wxVtkBaseView *wxvtkbaseview=NULL, vtkImageData	*imagedata=NULL);
		~wxWidgetVOI();
	    
		//if the MPR had generated the refresh event
		void OnRefreshView(wxCommandEvent & event);
		void OnDClickLeft(wxCommandEvent & event); 

		//refreshView
		void Refresh();

		ContourVOIWidget* GetContourVOIWidget();

  	    void setImageData(vtkImageData * imagedata);
		void setBaseView(wxVtkBaseView * wxvtkbaseview);

		void initializeVOIWidget();

	private:

//		ContourVOI			*mbbViewerMPR;
		ContourVOIWidget	*mcontourvoiwidget;

		wxVtkBaseView * wxvtkbaseview;
		vtkImageData * imagedata;
		

		

	DECLARE_EVENT_TABLE( );	    
  };
  
  //------------------------------------------------------------------------
  //------------------------------------------------------------------------
  //------------------------------------------------------------------------






class /*BBTK_EXPORT*/ ContourVOI
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ContourVOI,bbtk::WxBlackBox);
  BBTK_DECLARE_INPUT(Title,std::string);
    BBTK_DECLARE_INPUT(In, vtkImageData*);
    BBTK_DECLARE_INPUT(wxVtkBaseView, wxVtkBaseView*);
	BBTK_DECLARE_OUTPUT(Index,std::string);
	BBTK_DECLARE_OUTPUT(Size,std::string);
	BBTK_DECLARE_OUTPUT(VOI,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

private:
	vtkImageData* _img;
	wxVtkBaseView* _base;
	vtkExtractVOI*	_extract;

};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ContourVOI,bbtk::WxBlackBox);
BBTK_NAME("ContourVOI");
BBTK_AUTHOR("Eduardo.Davila [at] creatis.insa-lyon.fr");
BBTK_DESCRIPTION("define VOI widget");
//BBTK_CATEGORY("__CategoryBlackBox__");
    BBTK_INPUT(ContourVOI,Title,"Title prepended to the text",std::string,"");
	BBTK_INPUT(ContourVOI,In,"Input Image", vtkImageData *,"" );
	BBTK_INPUT(ContourVOI,wxVtkBaseView,"maracas visu wxVtkBaseView",wxVtkBaseView*,"");
	BBTK_OUTPUT(ContourVOI,Index, "Index"	,	std::string,"");
	BBTK_OUTPUT(ContourVOI,Size, "Size"	,	std::string,"");
	BBTK_OUTPUT(ContourVOI,VOI,"Region of interest",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(ContourVOI);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuContourVOI_h_INCLUDED__
#endif // _USE_WXWIDGETS_

