#ifndef __bbcreaMaracasVisuDrawAxisTree3D_h_INCLUDED__
#define __bbcreaMaracasVisuDrawAxisTree3D_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include <vtkProp3D.h>
#include <vtkRenderer.h>
#include "vtkImageData.h"
#include "vtkActor.h"
#include "vtkPolyData.h"
#include "vtkPolyDataMapper.h"
#include "vtkPoints.h"
#include "vtkCellArray.h"
#include "vtkProperty.h"

namespace bbcreaMaracasVisu
{

class /*BBTK_EXPORT*/ DrawAxisTree3D
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(DrawAxisTree3D,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(Renderer ,vtkRenderer*);
  BBTK_DECLARE_INPUT(lstIndexs,std::vector<int>);
  BBTK_DECLARE_INPUT(lstPointX,std::vector<double>);
  BBTK_DECLARE_INPUT(lstPointY,std::vector<double>);
  BBTK_DECLARE_INPUT(lstPointZ,std::vector<double>);
  BBTK_DECLARE_INPUT(lstRadio ,std::vector<double>);
  BBTK_DECLARE_INPUT(Colour   ,std::vector<double>);
  BBTK_DECLARE_INPUT(Transform, vtkLinearTransform *);
  BBTK_DECLARE_INPUT(iAxis, int );
  BBTK_DECLARE_OUTPUT(OutAxis,vtkProp3D *);
  BBTK_PROCESS(Process);
  void Process();

private:

	std::vector<vtkPolyData*>	vecVtkPolyData;
	std::vector<vtkPolyDataMapper*>	vecVtkPolyDataMaper;
	std::vector<vtkActor*>		vecVtkActors;

	void DrawOneAxis(int iGeneral,int numPoints, int iAxis);
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(DrawAxisTree3D,bbtk::AtomicBlackBox);
BBTK_NAME("DrawAxisTree3D");
BBTK_AUTHOR("InfoTeam CREATIS-LRMN");
BBTK_DESCRIPTION("Draw Axis Tree 3D");
BBTK_CATEGORY("actor");
BBTK_INPUT(DrawAxisTree3D,Renderer,"Renderer",vtkRenderer*,"");
BBTK_INPUT(DrawAxisTree3D,lstIndexs,"Indexs",std::vector<int>,"");
BBTK_INPUT(DrawAxisTree3D,lstPointX,"lstPointX",std::vector<double>,"");
BBTK_INPUT(DrawAxisTree3D,lstPointY,"lstPointY",std::vector<double>,"");
BBTK_INPUT(DrawAxisTree3D,lstPointZ,"lstPointZ",std::vector<double>,"");
BBTK_INPUT(DrawAxisTree3D,lstRadio,"lstRadio",std::vector<double>,"");
BBTK_INPUT(DrawAxisTree3D,Colour,"Colour",std::vector<double>,"");
BBTK_INPUT(DrawAxisTree3D,Transform,"vtkTransform", vtkLinearTransform *,"");
BBTK_INPUT(DrawAxisTree3D,iAxis,"iAxis",int,"");
BBTK_OUTPUT(DrawAxisTree3D,OutAxis,"Axis[iAxis]",vtkProp3D *,"");
BBTK_END_DESCRIBE_BLACK_BOX(DrawAxisTree3D);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuDrawAxisTree3D_h_INCLUDED__

