#include "bbmaracasvisuPlotterView.h"
#include "bbcreaMaracasVisuPackage.h"

#include "pPlotterScaleX.h"
#include "pPlotterScaleY.h"


namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,PlotterView)
BBTK_BLACK_BOX_IMPLEMENTATION(PlotterView,bbtk::WxBlackBox);

//---------------------------------------------------
void PlotterView::Process()
{
}

//---------------------------------------------------
void PlotterView::CreateWidget(wxWindow* parent)
{
   bbtkDebugMessageInc("Core",9,"PlotterView::CreateWxWindow()"<<std::endl);
    
   mwxwidget = new pPlotterWindow( parent , -1,wxDefaultPosition,  wxDefaultSize,  0 );
   mwxwidget->AddLayer(new pPlotterScaleX());
   mwxwidget->AddLayer(new pPlotterScaleY());
   
   // avoid 'taking address of temporary '
   //pGraphicalFunction *pGF = mwxwidget->getFunctionForVectors( &(bbGetInputInX()), &(bbGetInputInY()) ); // taking address of temporary ! JPRx
   std::vector<double> inX = bbGetInputInX();
   std::vector<double> inY = bbGetInputInY();
      
   pGraphicalFunction *pGF = mwxwidget->getFunctionForVectors( &inX, &inY ); 
   mwxwidget->addFunction(pGF);
   bbtkDebugDecTab("Core",9);
   bbSetOutputWidget( mwxwidget );
}

//---------------------------------------------------
void PlotterView::bbUserSetDefaultValues()
{
	mwxwidget = NULL;
}
	
	//-----------------------------------------------------------------	
	void PlotterView::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void PlotterView::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	

}
// EO namespace bbcreaMaracasVisu


