/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasApp.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__MARACAS__APP__H__
#define __WX__MARACAS__APP__H__

// ----------------------------------------------------------------------------
// wx headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <kernel/marInterface.h>
#include "wxMaracasFrame.h"

// 
#define SHOW_WINDOW_NORMAL 0 
#define SHOW_WINDOW_RESTORE 1
#define SHOW_WINDOW_MINIMIZED 2
#define SHOW_WINDOW_MAXIMIZED 3



/** 
 * \brief Maracas main application.
 */
class wxMaracasApp : public wxApp
{
public:
	void SetVolumeData(int dimX,int dimY,int dimZ, 
		               float spacingX, float spacingY, float spacingZ, 
					   float rescaleSlope, float rescaleIntercept,
					   unsigned short * pixels);
	void		ShowFrame(int cmdShow);
	bool		Initialized();
	void		Reset();
    bool		OnInit( );
    int			OnExit();
	void		Run();
	wxBitmap*	GetSnapshot();
private:
	bool			initialized;
    marInterface	*_mar;
    marSimpleDicom	*_marSimpleDicom;
	wxMaracasFrame* m_pFrame;
	void Initialize();

};

#endif // __WX__MARACAS__APP__H__
