/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracas_ManualTree_MPRDlg.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "wxMaracas_ManualTree_MPRDlg.h"
#include <wx/splitter.h>


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

wxMaracas_ManualTree_MPRDlg::wxMaracas_ManualTree_MPRDlg( wxWindow* parent, marImageData* marimagedata,double voxelSize)
 : wxDialog( parent, -1,_T("Manual Axis"),wxDefaultPosition,wxDefaultSize,wxCAPTION|wxRESIZE_BORDER  | wxMAXIMIZE_BOX )
{	
//	SetSize(700,700);
	Maximize(true);
	_parent=parent;
	wxSplitterWindow *splitPanel = new wxSplitterWindow(this ,-1);
	_manualTreeMPR = new wxMaracas_ManualTree_MPR(splitPanel,marimagedata,voxelSize);
	wxPanel *panel = new wxPanel (splitPanel, -1);

	wxButton *btnAccept = new wxButton (panel, wxID_OK, _T("Accept"));
	wxButton *btnCancel = new wxButton (panel, wxID_CANCEL, _T("Cancel"));

	wxBoxSizer* sizerH1 = new wxBoxSizer( wxHORIZONTAL );
	sizerH1->Add(btnAccept , 1, wxALL|wxEXPAND, 0);
	sizerH1->Add(btnCancel , 1, wxALL|wxEXPAND, 0);
	panel->SetAutoLayout(true);
	panel->SetSizer(sizerH1);
	Layout();
//EEDxx2.4
//	FitInside();


	splitPanel->SplitHorizontally(_manualTreeMPR,panel );
	splitPanel->SetMinimumPaneSize(50);

	wxBoxSizer* sizer = new wxBoxSizer( wxVERTICAL );
	sizer->Add(splitPanel , 1, wxALL|wxEXPAND, 0);
	SetAutoLayout(true);
	SetSizer(sizer);
	Layout();
//EEDxx2.4
//	FitInside();
}

//----------------------------------------------------------------------------

wxMaracas_ManualTree_MPRDlg::~wxMaracas_ManualTree_MPRDlg()
{
}

//----------------------------------------------------------------------------

void wxMaracas_ManualTree_MPRDlg::ConfigureVTK()
{
	wxBusyCursor wait;
	_manualTreeMPR->ConfigureVTK();
}

//----------------------------------------------------------------------------

void wxMaracas_ManualTree_MPRDlg::SetMarAxis( marAxis *maraxis  )
{
	_maraxis=maraxis;
}

//----------------------------------------------------------------------------
bool wxMaracas_ManualTree_MPRDlg::ExportPoints()
{
	bool ok=false;
	double t,x,y,z;
	manualContourModel *manualcontourmodel = _manualTreeMPR->GetManualContourModel();

	double spc[3];
	_manualTreeMPR->GetVtkMPRBaseData()->GetImageData()->GetSpacing(spc);

	int sizeLstPoints = manualcontourmodel->GetSizeLstPoints(); 

	if ( sizeLstPoints>=2 ){ 
		manualcontourmodel->UpdateSpline();
		int i,max=200;
//JSTG 25-02-08 ---------------------------------------------------
		//double delta = ((double)sizeLstPoints-1) / (double)max;
		for (i=0;i<max;i++)
		{	
			//t=delta*(double)i;
			//manualcontourmodel->GetSplinePoint(t,x,y,z);
			manualcontourmodel->GetSpline_i_Point(i,&x,&y,&z);
//-----------------------------------------------------------------
			x=x*spc[0];
			y=y*spc[1];
			z=z*spc[2];
			_maraxis->AddPointToList(x, y, z,100);		
		}
		ok=true;
	}
	return ok;
}



// EOF - wxMaracas_ManualTree_MPRDlg.cxx




