

#include "ContourView.h"


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ContourView::ContourView()
{
	_wxvtkbaseview = NULL;
}

// ----------------------------------------------------------------------------
ContourView::~ContourView()
{
	DeleteContours();
}

// ----------------------------------------------------------------------------
void ContourView::DeleteContours()
{
	DeleteVtkObjects();
	contour_mapped.clear();
	contour_actor.clear();
}

// ----------------------------------------------------------------------------
void ContourView::SetWxVtkBaseView(wxVtkBaseView *wxvtkbaseview)
{
	_wxvtkbaseview = wxvtkbaseview;
}

// ----------------------------------------------------------------------------
void ContourView::Refresh()
{
	_wxvtkbaseview->GetRenWin()->Render();
}

// ----------------------------------------------------------------------------
void ContourView::CreateNewContour(vtkPolyData *contour, int type)
{
	contour_mapped.push_back(vtkPolyDataMapper::New());
	contour_mapped.back()->ImmediateModeRenderingOn();
	contour_mapped.back()->ScalarVisibilityOff( );
	contour_mapped.back()->SetInput(contour);

	contour_actor.push_back(vtkActor::New());
	contour_actor.back()->SetMapper(contour_mapped.back());
	contour_actor.back()->GetProperty()->BackfaceCullingOff();
	
	switch (type)
	{
	case ContourView::BLUE :	contour_actor.back()->GetProperty()->SetDiffuseColor(0, 0, 1);
								break;
	case ContourView::MAGENTA : contour_actor.back()->GetProperty()->SetDiffuseColor(1, 0, 1);
								break;
	case ContourView::GREEN :	contour_actor.back()->GetProperty()->SetDiffuseColor(0, 1, 0);
								break;
	case ContourView::YELLOW :	contour_actor.back()->GetProperty()->SetDiffuseColor(0, 1, 1);
								break;
	default:					contour_actor.back()->GetProperty()->SetDiffuseColor(0, 0, 1);

	}
	contour_actor.back()->GetProperty()->SetLineWidth(2);
	contour_actor.back()->ApplyProperties();

	_wxvtkbaseview->GetRenderer()->AddActor(contour_actor.back());
	_wxvtkbaseview->GetRenWin()->Render();
}

// ----------------------------------------------------------------------------
void ContourView::DeleteVtkObjects()
{
	int i,size=contour_mapped.size();
	for (i=0;i<size; i++){
		if ( contour_mapped[i]	!= NULL	)	{ 
			contour_mapped[i]  -> Delete(); 
		}
		if ( contour_actor[i]	!= NULL	)	{ 
			_wxvtkbaseview->GetRenderer()->RemoveActor(contour_actor[i]);
			contour_actor[i]  -> Delete(); 
		}
		contour_actor[i] = NULL;
		contour_mapped[i] = NULL;
	}
}
