

#include "LineView.h"




// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
LineView::LineView()
{
	_wxvtkbaseview = NULL;
}

// ----------------------------------------------------------------------------
LineView::~LineView()
{
	DeleteLines();
}

// ----------------------------------------------------------------------------
void LineView::DeleteLines() 
{
	DeleteVtkObjects();
	contour_mapped.clear();
	contour_actor.clear();
}

// ----------------------------------------------------------------------------
void LineView::SetWxVtkBaseView(wxVtkBaseView *wxvtkbaseview)
{
	_wxvtkbaseview = wxvtkbaseview;
}

// ----------------------------------------------------------------------------
void LineView::Refresh()
{
	_wxvtkbaseview->GetRenWin()->Render();
}

// ----------------------------------------------------------------------------
void LineView::CreateNewLine(double x1, double y1, double z1, double x2, double y2, double z2)
{

	vtkPoints*  pointsLine = vtkPoints::New();
	vtkPolyLine* aLine = vtkPolyLine::New();
	vtkUnstructuredGrid* aLineGrid = vtkUnstructuredGrid::New();
	contour_mapped.push_back(vtkDataSetMapper::New());
	contour_actor.push_back(vtkActor::New());

    pointsLine->SetNumberOfPoints(2);
	pointsLine->InsertPoint(0,x1,y1,z1);
	pointsLine->InsertPoint(1,x2,y2,z2);

	(aLine->GetPointIds())->SetNumberOfIds(2);
	(aLine->GetPointIds())->SetId(0,0);
	(aLine->GetPointIds())->SetId(1,1);

	aLineGrid->Allocate(1,1);
	aLineGrid->InsertNextCell(aLine->GetCellType(),aLine->GetPointIds());
	aLineGrid->SetPoints(pointsLine);

	
	contour_mapped.back()->SetInput(aLineGrid);
	contour_mapped.back()->ImmediateModeRenderingOn();

	contour_actor.back()->SetMapper(contour_mapped.back());
	contour_actor.back()->GetProperty()->BackfaceCullingOn();
	contour_actor.back()->GetProperty()->SetDiffuseColor(0, 0, 1);
	contour_actor.back()->ApplyProperties();

	_wxvtkbaseview->GetRenderer()->AddActor(contour_actor.back());
	_wxvtkbaseview->GetRenWin()->Render();

}

// ----------------------------------------------------------------------------
void LineView::DeleteVtkObjects()
{
	int i,size=contour_mapped.size();
	for (i=0;i<size; i++){
		if ( contour_mapped[i]	!= NULL	)	{ 
			contour_mapped[i]  -> Delete(); 
		}
		if ( contour_actor[i]	!= NULL	)	{ 
			_wxvtkbaseview->GetRenderer()->RemoveActor(contour_actor[i]);
			contour_actor[i]  -> Delete(); 
		}
		contour_actor[i] = NULL;
		contour_mapped[i] = NULL;
	}
}

