                                                                    

/**
 *  \file 
 *  \brief ClassThresholdImageViewPanel . 
 */


#include "ThresholdImageViewPanel.h"



/**
 ** Begin of the threshold panel
 **/
ThresholdImageViewPanel::ThresholdImageViewPanel(wxWindow* parent, int min, int max, int type)
: wxPanel(parent, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_SUNKEN)
{
	_thresholdImageView = new ThresholdImageView();

//	wxButton *thresholdGoBtn = new wxButton(this,wxID_ANY,_T("Show/Hide Color"), wxDefaultPosition, wxSize(200,30) );
	
	_thresholdGo = true;
	_cb_ShowHide = new wxCheckBox(this, wxID_ANY, _T("Show/Hide layer") );
	_cb_ShowHide->SetValue(_thresholdGo);
	
	_interpolationCheckBox = new wxCheckBox(this, -1, _T("Image interpolation") );
	_interpolationCheckBox->SetValue(true);	
	_opacity = new wxSlider(this, wxID_ANY, 6, 1, 10, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_LABELS, wxDefaultValidator);
	
//	double range[2];
//	interfMainPanel::getInstance()->getImageRange(range);
	
//	int min = (int)floor (range[0]);
//	int max = (int)ceil (range[1]);

	if (type==0)
	{
	}
	
	if (type==1)
	{
		_mBarThreshold	=  new mBarRange(this,70,65);
		_mBarThreshold->SetMin(0);
		_mBarThreshold->SetStart(0);
		_mBarThreshold-> SetOrientation( true );
		_mBarThreshold-> setActiveStateTo(true);
		_mBarThreshold-> setVisibleLabels( true );
		_mBarThreshold-> setDeviceEndMargin(10);
		_mBarThreshold-> setRepresentedValues( min , max );
		_mBarThreshold-> setDeviceBlitStart(10,10); 
		_mBarThreshold-> setIfWithActualDrawed( false );
		_mBarThreshold-> SetStart( min );
		_mBarThreshold-> SetEnd( max );  
	}
	
	
	Connect( _cb_ShowHide->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED , (wxObjectEventFunction) &ThresholdImageViewPanel::onThresholdShow ); 
	Connect( _interpolationCheckBox->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED, (wxObjectEventFunction) &ThresholdImageViewPanel::onThresholdInterpolation );
	
	wxFlexGridSizer * sizer		= new wxFlexGridSizer(1);
	if (type==1)
	{
		sizer -> Add( new wxStaticText(this,-1,_T("Image Threshold"))  , 1, wxGROW );
		sizer -> Add( _mBarThreshold, 1, wxGROW );
		sizer -> Add( new wxStaticText(this,-1,_T(" "))  , 1, wxGROW );
	}
	sizer -> Add( new wxStaticText(this,-1,_T("Opacity Level"))  , 1, wxGROW );
	sizer -> Add( _opacity, 1, wxGROW );
	sizer -> Add( new wxStaticText(this,-1,_T(" "))  , 1, wxGROW );
	sizer -> Add( _cb_ShowHide, 1, wxGROW );
	sizer -> Add( new wxStaticText(this,-1,_T(" "))  , 1, wxGROW );
	sizer -> Add( _interpolationCheckBox, 1, wxGROW );
	
	this->SetSizer( sizer );
	this->SetAutoLayout( true );
	this->Layout();
}

//----------------------------------------------------------------------------
ThresholdImageViewPanel::~ThresholdImageViewPanel()
{
}


//----------------------------------------------------------------------------
void ThresholdImageViewPanel::SetThresholdImageView(ThresholdImageView* thresholdImageView)
{
	_thresholdImageView = thresholdImageView;
}


//----------------------------------------------------------------------------
void ThresholdImageViewPanel::onThresholdChange(wxCommandEvent& event)
{
	if (_thresholdGo)
	{
		_thresholdImageView->SetminMaxValue( _mBarThreshold->GetStart(), _mBarThreshold->GetEnd() );
		_thresholdImageView->onThresholdChange();
		_thresholdImageView->GetwxVtkBaseView()->Refresh();
		//std::cout<< "Valor Min: " << minVal << " & Valor Max: " << maxVal  << std::endl;
	}
}

//----------------------------------------------------------------------------
void ThresholdImageViewPanel::onThresholdShow(wxCommandEvent& event)
{
	_thresholdGo = _cb_ShowHide->GetValue();
	if (_thresholdGo)
	{
		_thresholdImageView->onThreshold();
	}
	else
	{	
		_thresholdImageView->onThresholdRemove( );
	}
	_thresholdImageView->GetwxVtkBaseView()->Refresh();
}

//----------------------------------------------------------------------------
void ThresholdImageViewPanel::onThresholdStop()
{
	if (_thresholdGo)
	{	
		_thresholdImageView->onThresholdRemove( );
		_thresholdGo=false;		
	}
}

//----------------------------------------------------------------------------
void ThresholdImageViewPanel::onThresholdInterpolation(wxCommandEvent& event)
{
	_thresholdImageView->onThresholdInterpolation(_interpolationCheckBox->GetValue());
	_thresholdImageView->GetwxVtkBaseView()->Refresh();

}

//----------------------------------------------------------------------------
void ThresholdImageViewPanel::onChangeOpacity(wxScrollEvent& event)
{
	int opacity = _opacity->GetValue();
	_thresholdImageView->onThresholdChangeOpacity(opacity);
	_thresholdImageView->GetwxVtkBaseView()->Refresh();
}


//----------------------------------------------------------------------------
bool ThresholdImageViewPanel::IsVisible()
{
	return _thresholdGo;
}


BEGIN_EVENT_TABLE(ThresholdImageViewPanel, wxPanel)
  EVT_COMMAND(wxID_ANY, wxEVT_TSBAR_START, ThresholdImageViewPanel::onThresholdChange)
  EVT_COMMAND(wxID_ANY, wxEVT_TSBAR_END, ThresholdImageViewPanel::onThresholdChange)
  EVT_COMMAND(wxID_ANY, wxEVT_TSBAR_MOVED, ThresholdImageViewPanel::onThresholdChange)	
  EVT_SCROLL(ThresholdImageViewPanel::onChangeOpacity)
END_EVENT_TABLE()



// EOF

