#ifndef creaContoursFactory_h
#define creaContoursFactory_h

#include "manualContourControler.h"
#include "manualBaseModel.h"
#include "manualViewBaseContour.h"
#include "manualCircleControler.h"
#include "manualContourModelCircle.h"
#include "manualViewCircle.h"
#include "manualLineControler.h"
#include "manualContourModelLine.h"
#include "manualViewLine.h"
#include "manualRoiControler.h"
#include "manualViewRoi.h"
#include "manualContourModelRoi.h"
#include "manualViewBullEye.h"
#include "manualContourModelBullEye.h"
#include "manualViewPoints.h"
#include "manualRotationToolControler.h"
#include "manualContourModelRotationTool.h"
#include "manualViewRotationTool.h"
#include "manualContourModelPolygon.h"

class creaMaracasVisu_EXPORT creaContoursFactory
{

//--------------------------- virtual ~manualBaseModel();------------------------
// PUBLIC METHODS & ATTS
//---------------------------------------------------

	public:
		creaContoursFactory();
		virtual ~creaContoursFactory();

		/* Creates the controler of the contour given the number of the contour*/
		manualContourBaseControler* getContourControler(int typeContour);

		/* Creates the controler of the contour given the name of the contour*/
		manualContourBaseControler* getContourControler(std::string typeContour);

		/* Creates the model of the contour given the number of the contour*/
		manualBaseModel* getContourModel(int typeContour);

		/* Creates the model of the contour given the name of the contour*/
		manualBaseModel* getContourModel(std::string typeContour);

		/* Creates the viewer of the contour given the number of the contour*/
		manualViewBaseContour* getCountourView(int typeContour);

		/* Creates the viezer of the contour given the name of the contour*/
		manualViewBaseContour* getCountourView(std::string typeContour);		
};

#endif