#include "manualViewBullEye.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

manualViewBullEye::manualViewBullEye()
{
}

// ----------------------------------------------------------------------------
manualViewBullEye::~manualViewBullEye()
{
	// BullEye(s)
	int i,size=lstSectorBullEye.size();
	for (i=0;i<size;i++)
	{
		delete lstSectorBullEye[i];
	}
	lstSectorBullEye.clear();
}


// ----------------------------------------------------------------------------
manualViewBullEye * manualViewBullEye :: Clone()
{
	manualViewBullEye * clone = new manualViewBullEye();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------

void manualViewBullEye::CopyAttributesTo( manualViewBullEye * cloneObject)
{
	// Fathers object
	manualViewBaseContour::CopyAttributesTo(cloneObject);
}


// ----------------------------------------------------------------------------
int manualViewBullEye::GetType() // virtual
{
	return 4;
}


// ----------------------------------------------------------------------------
void manualViewBullEye::RefreshContour() // virtual
{
	// External Rectangle
	manualViewRoi::RefreshContour();

	_manContModel->UpdateSpline();
    int np	= GetNumberOfPoints( );
	// Refres sectors of BullEye(s)

	if (np>=2  )
	{
		int i,size = lstSectorBullEye.size();
		for (i=0;i<size;i++)
		{
			lstSectorBullEye[i]->RefreshContour();
		} // for
	} // if


}

// ----------------------------------------------------------------------------
void manualViewBullEye::ConstructVTKObjects() // virtual
{
	manualViewRoi::ConstructVTKObjects();

	double spc[3];
	this->GetSpacing(spc);
	manualViewBullEyeSector *mvbc;
	manualContourModelBullEye *mcmbe = (manualContourModelBullEye*)this->_manContModel;
	int i,size = mcmbe->GetSizeOfSectorLst();
	for ( i=0 ; i<size ; i++ )
	{
		mvbc = new manualViewBullEyeSector();
		mvbc->SetModel( mcmbe->GetModelSector(i) );
		mvbc->SetWxVtkBaseView( this->GetWxVtkBaseView()  );
		mvbc->SetRange( 2 );
		mvbc->SetZ( 1000 );
		mvbc->SetSpacing(spc);
		mvbc->SetColorNormalContour(1, 0, 0);
//		mvbc->SetColorEditContour(0.5, 0.5, 0.5);
//		mvbc->SetColorSelectContour(1, 0.8, 0);
		mvbc->SetWidthLine( this->GetWidthLine()  );
//EED004
		mvbc->ConstructVTKObjects();
		lstSectorBullEye.push_back( mvbc );
	}


}

// ----------------------------------------------------------------------------
void manualViewBullEye::AddSplineActor()  // virtual
{
	manualViewRoi::AddSplineActor();
	int i,size=lstSectorBullEye.size();
	for (i=0;i<size;i++)
	{
		lstSectorBullEye[i]->AddSplineActor();
	}
}

// ----------------------------------------------------------------------------
void manualViewBullEye::RemoveSplineActor()  // virtual
{
	manualViewRoi::RemoveSplineActor();
	int i,size=lstSectorBullEye.size();
	for (i=0;i<size;i++)
	{
		lstSectorBullEye[i]->RemoveSplineActor();
	}
}
