#include "vtkmyPWCallback_3DPointWidget.h"
#include "vtkInteractorStyleBaseView.h"

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
void vtkmyPWCallback_3DPointWidget::Execute(vtkObject *caller, unsigned long, void*)
{
	double n[3];
	double p[3];
	double delta = 0.000000001;

	vtkInteractorStyleBaseView *isbv = (vtkInteractorStyleBaseView*)_wxvtkmpr3Dview->GetWxvtk3Dbaseview()->GetInteractorStyleBaseView();

	if (caller==_pointWidget)
	{
		_pointWidget->GetPosition(p);
	}
	if (caller==_planeWidget)
	{
		_planeWidget->GetCenter(p);
		_planeWidget->GetNormal(n);
		_wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->SetNormal(n[0],n[1],n[2]);
	}

	double spc[3];
	_wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData()->GetSpacing(spc);
	p[0]=p[0]/spc[0];
	p[1]=p[1]/spc[1];
	p[2]=p[2]/spc[2];

	// Orientation change
	if ( (fabs(n[0]-_backNormal[0])>delta) || (fabs(n[1]-_backNormal[1])>delta) || (fabs(n[2]-_backNormal[2])>delta) )
	{
		_backNormal[0] = n[0];
		_backNormal[1] = n[1];
		_backNormal[2] = n[2];
		isbv->SetParent_refresh_waiting();
	}

	// ----------

	double tx = _wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetX();
	double ty = _wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetY();
	double tz = _wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetZ();

	// Position Change
	if ( (fabs(tx-p[0])>delta) || (fabs(ty-p[1])>delta) || (fabs(tz-p[2])>delta) )
	{
		_wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->SetX( p[0] );
		_wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->SetY( p[1] );
		_wxvtkmpr3Dview->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->SetZ( p[2] );
		vtkInteractorStyleBaseView *isbv = (vtkInteractorStyleBaseView*)_wxvtkmpr3Dview->GetWxvtk3Dbaseview()->GetInteractorStyleBaseView();
		isbv->BlockRefresh();
		isbv->vtkInteractorStyleBaseView::OnLeftButtonDown();
		isbv->SetParent_refresh_waiting();
		isbv->vtkInteractorStyleBaseView::OnMouseMove();
		isbv->UnBlockRefresh();
	} 
	isbv->EvaluateToRefresh();
}
//-------------------------------------------------------------------
void vtkmyPWCallback_3DPointWidget::SetWxVtkMPR3DView( wxVtkMPR3DView *wxvtkmpr3Dview )
{
	_wxvtkmpr3Dview=wxvtkmpr3Dview;
}
//-------------------------------------------------------------------
void vtkmyPWCallback_3DPointWidget::SetVtkPointWidget( vtkPointWidget *pointWidget )
{
	_pointWidget=pointWidget;
}
//-------------------------------------------------------------------
void vtkmyPWCallback_3DPointWidget::SetVtkPlaneWidget( vtkPlaneWidget *planeWidget )
{
	_planeWidget=planeWidget;
}

