#ifndef WXMARACASSURFACERENDERINGPANEL_H_
#define WXMARACASSURFACERENDERINGPANEL_H_

#include "wx/wx.h"

class wxMaracasSurfaceRenderingPanel : public wxPanel{
public:
	wxMaracasSurfaceRenderingPanel(wxWindow* parent, int propid, bool _isComplexBox, int _panID)
		: wxPanel(parent, -1, wxDefaultPosition, wxDefaultSize){
			createPanel();
			isComplexBox = _isComplexBox;
			panID = _panID;
			_propid = propid;
	}	
	//virtual ~wxMaracasSurfaceRenderingPanel();
	virtual void createPanel(){
		show = false;
        /*wxBoxSizer* sizerButtons = new wxBoxSizer(wxVERTICAL);

		wxButton* b = new wxButton(this, -1, wxString(_T("-")), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT, 
								wxDefaultValidator, wxString(_T("-")));	
		Connect(b->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&wxMaracasSurfaceRenderingPanel::onActionButtonPressedHide);
		wxButton* b1 = new wxButton(this, -1, wxString(_T("-")), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT, 
								wxDefaultValidator, wxString(_T("x")));	
		Connect(b1->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&wxMaracasSurfaceRenderingPanel::onActionButtonPressedEliminate);

		sizerButtons->Add(b, wxFIXED_MINSIZE);
		sizerButtons->Add(b1, wxFIXED_MINSIZE);*/

		sizercontrols = new wxBoxSizer(wxVERTICAL);

		wxBoxSizer* sizerpanel = new wxBoxSizer(wxHORIZONTAL);

		//sizerpanel->Add(sizerButtons,wxGROW);
		sizerpanel->Add(sizercontrols,wxGROW);
	
		this->SetSizer(sizerpanel, true);		
		this->SetAutoLayout( true );
	}

	/**
	**	Adds a new control to the panel (sizer, radiob, etc)
	**/
	virtual void addControl(wxWindow* win){
		if(sizercontrols!=NULL){
			sizercontrols->Add(win, wxGROW);
		}
	}

	/**
	**	Adds a new control to the panel (sizer, radiob, etc)
	**/
	virtual void addControl(wxSizer* sizer){
		if(sizercontrols!=NULL){
			sizercontrols->Add(sizer, wxGROW);
		}
	}

	/**
	**	Hides or show the controls in the panel
	**/
	virtual void onActionButtonPressedHide( wxCommandEvent& event ){
		wxList list = sizercontrols->GetChildren();		
		int i;
		for(i=0; i<list.size();i++){
			sizercontrols->Show(i,show);
		}
		show = !show;
		sizercontrols->Layout();
		this->Layout();
	}

    /**
	**	The user must implement this function to remove the panel from the 
	**/
	//virtual void onActionButtonPressedEliminate( wxCommandEvent& event )=0;

	/**
	**	The user must implement this function to add the necessary controls to the panel
	**/
	virtual void createControls( )=0;
	
	/**
	** returns the id of the panel
	**/
	int getPropId(){
		return _propid;
	}

	/**
	** Returns the papnel id
	**/
	int getPanId(){
		return panID;
	}

	/**
	** Tells if the panel is used for a complex box
	**/
	bool isComplex(){
		return isComplexBox;
	}

private:
	wxBoxSizer* sizercontrols;
	bool show;
protected:
	int _propid;
	
	//-- Atributes added for complex box --//
	bool isComplexBox;
	int panID;
};

#endif /*WXMARACASSURFACERENDERINGPANEL_H_*/
