/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracas_N_ViewersWidget.h,v $
  Language:  C++
  Date:      $Date: 2009/11/30 20:52:51 $
  Version:   $Revision: 1.9 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__MARACAS__N_VIEWERSWIDGET__H__
#define __WX__MARACAS__N_VIEWERSWIDGET__H__


// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include "vtkImageData.h"
#include "wxMaracas_ViewerWidget.h"
#include <iostream>
#include <vector>

//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------

class creaMaracasVisu_EXPORT wxMaracas_N_ViewersWidget : public wxPanel
  {
  public:

	  	  
	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

	wxMaracas_N_ViewersWidget(wxWindow *parent, vtkImageData* imagedata = NULL, std::vector<int> *nTypeView = NULL);
    ~wxMaracas_N_ViewersWidget();

	
	//------------------------------------------------------------------------------------------------------------
	// Methods
	//------------------------------------------------------------------------------------------------------------

    void Update();
    vtkRenderer *GetRenderer();
	void RefreshView();

	virtual void OnRefreshView(wxCommandEvent & event);
	void OnDClickLeft(wxCommandEvent & event);
	wxMaracas_ViewerWidget *GetWindow(int iWin);
	wxVtkBaseView *GetwxVtkBaseView(int iWin);
 	virtual void Refresh(bool eraseBackground = true,const wxRect* rect = NULL );
	void SetImage( vtkImageData *image	);
	void ConfigureVTK();
	void SetType(std::vector<int>* type);
	void UpdateLayout(vtkImageData* imagedata);
//	double GetZ(int iWin);
	double GetX();
	double GetY();
	double GetZ();

	void setColorTransferFunction(vtkColorTransferFunction* colortable);

	void setWindowLevel(double level);
	void setColorLevel(double level);

	//------------------------------------------------------------------------------------------------------------
	// Attributes
	//------------------------------------------------------------------------------------------------------------

  private:
	
	wxMaracas_ViewerWidget	*wxwindow1;
	wxMaracas_ViewerWidget	*wxwindow2;
	wxMaracas_ViewerWidget	*wxwindow3;
	wxMaracas_ViewerWidget	*wxwindow4;

	wxWindow *_currentwxw;


	std::vector<int> *nTypeView;

	vtkMPRBaseData* mvtkmprbasedata;  
	  
  DECLARE_EVENT_TABLE( );
  };


#endif // __WX__MARACAS__N_VIEWERWIDGET__H__
