#ifndef PlaneDirectionManager_H_
#define PlaneDirectionManager_H_

#include <math.h>

#include <iostream>

#include "PlaneDirectionManagerData.h"

#include <vector>

#include <vtkRenderer.h>

class PlaneDirectionManager  {

public:
	PlaneDirectionManager(int radio, double colour[3], int opacity);	
	~PlaneDirectionManager();	
	
	void SetRenderer(vtkRenderer* render);
	void SetVectors( std::vector<double> lstPointsx, std::vector<double> lstPointsy, std::vector<double> lstPointsz);

	void UpdateDirections() throw (std::exception);

	std::vector<PlaneDirectionManagerData*> GetPlanesData(){
		return _vectdata;
	}

	void addRemoveActor(int index, bool addremove);

	void changeColor(int index,double r,double g,double b);

	PlaneDirectionManagerData* GetPlaneDirectionManagerData(int id);

	void WriteInformation(std::string  filename, double* spc=NULL);

	void SetArrowSize(int arrowsize);
private:

	std::vector<double> _lstPointsx;
	std::vector<double> _lstPointsy;
	std::vector<double> _lstPointsz;

	std::vector<PlaneDirectionManagerData*> _vectdata;

	void RemoveAllActorsFromIndex(int n=0)throw (std::exception);
	void UpdateVectors()throw (std::exception);

	void UpdateActors();
	void AddActors();

	vtkRenderer* _render;

	int _radio;
	double* _colour;
	int _opacity;
	
};

#endif /*PlaneDirectionManager_H_*/
